View Issue Details

IDProjectCategoryView StatusLast Update
0000346WishesMacropublic2013-02-03 04:33
ReporterTSAssigned Tovskirdin 
PrioritynormalSeverityfeatureReproducibilityhave not tried
Status closedResolutionfixed 
Product Version 
Target VersionFixed in Version3.0 
Summary0000346: Возможность построения меню выбора выполняющегося макроса
DescriptionПредлагается ввести макрокомманды $Menu({Menu_Title},{Menu_Item_1}[,Menu_Item_i])
и
$MenuItem({Item_Text},{Item_Macro})
где
{Menu_Title} - заголовок меню
{Item_Text} - текст строки (пункта) меню
{Item_Macro} - текст макро, выполняющегося при выборе пункта меню

пример
$Menu("Пример меню",$MenuItem("Help","F1"),$MenuItem("Quit","F10"))

Назначение: группирование однотипных макро в одно меню
TagsNo tags attached.
Build1983

Relationships

duplicate of 0001751 closed Wishes Создание меню в макросе 
parent of 0000466 closedshmuel Wishes Расширение макроязыка плагинами 
has duplicate 0001519 closed Far Manager Создание меню в макросах 

Activities

vskirdin

2008-03-25 06:35

administrator   bugnote:0001422

С переменным числом агруметов в макрофункциях пока проблема...
Т.к. заполнение стека - паскалеподобное (т.е. на вершине лежит последний параметр).
Для реализации задумки... необходима переделка компилятора (возможно значительная)...

DrKnS

2008-03-25 07:29

administrator   bugnote:0001423

А зачем $MenuItem? Лучше по аналогии с msgbox: Menu - функция, возвращает 0, если отменили, или выбранный пункт, начиная с 1.

Переменное число агрументов можно превратить в постоянное, склеив их в строку:
Menu("title","item0|item1|item2|..."),
которую макродвижок потом распарсит. Но от этого попахивает кривизной.

vskirdin

2008-11-28 18:08

administrator   bugnote:0002060

поставил зависимости от 0000466
т.е. предлагается дождаться решения 0000466 - это позволит написать плагин, который бы экспортировал функцию, аля Menu("title","item0|item1|item2|...")

vskirdin

2011-08-18 16:05

administrator   bugnote:0007493

см. 0001751

Issue History

Date Modified Username Field Change
2007-10-31 13:07 TS New Issue
2007-10-31 13:07 TS Status new => assigned
2007-10-31 13:07 TS Assigned To => vskirdin
2007-10-31 14:12 vskirdin Project Far Manager 1.7x => Wishes
2008-03-25 06:35 vskirdin Note Added: 0001422
2008-03-25 07:29 DrKnS Note Added: 0001423
2008-11-28 18:08 vskirdin Note Added: 0002060
2009-09-30 10:28 vskirdin Relationship added parent of 0000466
2010-09-27 15:40 DrKnS Relationship added has duplicate 0001519
2011-08-18 16:04 vskirdin Relationship added duplicate of 0001751
2011-08-18 16:05 vskirdin Build => 1983
2011-08-18 16:05 vskirdin Note Added: 0007493
2011-08-18 16:05 vskirdin Status assigned => closed
2011-08-18 16:05 vskirdin Resolution open => fixed
2011-08-18 16:05 vskirdin Fixed in Version => 3.0
2013-02-03 04:33 alexy Severity minor => feature